//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrDimGray  
#property indicator_color3  clrSandyBrown
#property indicator_color4  clrDeepSkyBlue
#property indicator_color5  clrDeepSkyBlue
#property indicator_color6  clrSandyBrown
#property indicator_color7  clrSandyBrown
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame      = PERIOD_CURRENT; // Time frame to use
extern int             CalcPeriod     = 20;             // Calculation length
extern int             LineWidth      = 2;              // Line display width
extern bool            Interpolate    = true;           // Interpolate in multi time frame mode?

//
//
//
//
//

double tzon[];
double tzonua[];
double tzonub[];
double tzonda[];
double tzondb[];
double levup[],levmi[],levdn[],trend[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,levup);
   SetIndexBuffer(1,levmi);
   SetIndexBuffer(2,levdn);
   SetIndexBuffer(3,tzonua);
   SetIndexBuffer(4,tzonub);
   SetIndexBuffer(5,tzonda);
   SetIndexBuffer(6,tzondb);
   SetIndexBuffer(7,trend);
      for (int i=3; i<7; i++) SetIndexStyle(i,DRAW_LINE,EMPTY,LineWidth);

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { levup[0] = limit+1; return(0); }
            if (TimeFrame != _Period)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
               if (trend[limit]== 1) CleanPoint(limit,tzonua,tzonub);
               if (trend[limit]==-1) CleanPoint(limit,tzonda,tzondb);
               for (int i=limit;i>=0;i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     levup[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CalcPeriod,0,y);
                     levmi[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CalcPeriod,1,y);
                     levdn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CalcPeriod,2,y);
                     trend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CalcPeriod,7,y);
                     tzonua[i] = EMPTY_VALUE;
                     tzonub[i] = EMPTY_VALUE;
                     tzonda[i] = EMPTY_VALUE;
                     tzondb[i] = EMPTY_VALUE;

                     //
                     //
                     //
                     //
                     //
      
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                     int n,k; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;	
                        for(k = 1; i+n<Bars && i+k<Bars && k<n; k++)
                        {
                           levup[i+k] = levup[i] + (levup[i+n]-levup[i])*k/n;
                           levmi[i+k] = levmi[i] + (levmi[i+n]-levmi[i])*k/n;
                           levdn[i+k] = levdn[i] + (levdn[i+n]-levdn[i])*k/n;
                        }
               }
               for (int i=limit;i>=0;i--)
               {
                  if (trend[i]== 1 || trend[i]==0) PlotPoint(i,tzonua,tzonub,levup);
                  if (trend[i]==-1 || trend[i]==0) PlotPoint(i,tzonda,tzondb,levdn);
               }
               return(0);
            }               

   //
   //
   //
   //
   //
   
      if (trend[limit]== 1 || trend[limit]==0) CleanPoint(limit,tzonua,tzonub);
      if (trend[limit]==-1 || trend[limit]==0) CleanPoint(limit,tzonda,tzondb);
      for(int i = limit; i >= 0; i--)
      {
         tzonua[i] = EMPTY_VALUE;
         tzonub[i] = EMPTY_VALUE;
         tzonda[i] = EMPTY_VALUE;
         tzondb[i] = EMPTY_VALUE;
         levup[i]  = High[ArrayMaximum(High,CalcPeriod,i)];
         levdn[i]  = Low [ArrayMinimum(Low ,CalcPeriod,i)];
         levmi[i]  = (levup[i]+levdn[i])/2.0;
         trend[i]  = -99;
         if (i<(Bars-1))
         {
            trend[i] = trend[i+1];
            if (High[i]==levup[i])                     trend[i]= 1;
            if (Low[i] ==levdn[i])                     trend[i]=-1;
            if (High[i]==levup[i] && Low[i]==levdn[i]) trend[i]= 0;
         

            if (trend[i]== 1 || trend[i]==0) PlotPoint(i,tzonua,tzonub,levup);
            if (trend[i]==-1 || trend[i]==0) PlotPoint(i,tzonda,tzondb,levdn);
         }            
      }
      return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}